#!/usr/bin/python
#from albatross import SimpleSessionApp, SessionAppContext
from albatross import SimpleSessionFileApp, SessionFileAppContext
from albatross.cgiapp import Request

import time

DEBUG_FLAG = 0

def pdebug(appid, msg):
    if DEBUG_FLAG:
        of = file('/w2/Tmp/Logs/test.log', 'a')
        of.write('[%s][%s] %s' % (appid, time.ctime(), msg))
        of.close()


class StartPage:
    name = 'start'
    def page_process(self, ctx):
        pdebug(ctx.sesid(), '(StartPage.page_process)\n')
        ctx.add_session_vars('value_1', 'value_2')
        if ctx.req_equals('next_page'):
            if ctx.locals.next_page == 'page1':
                ctx.set_page('page1')
            elif ctx.locals.next_page == 'page2':
                ctx.set_page('page2')
                # Set the checkbox.
                ctx.locals.next_page = 'page3'
    def page_enter(self, ctx):
        pdebug(ctx.sesid(), '(StartPage.page_enter)\n')
    def page_leave(self, ctx):
        pdebug(ctx.sesid(), '(StartPage.page_leave)\n')
    def page_display(self, ctx):
        pdebug(ctx.sesid(), '(StartPage.page_display)\n')
        ctx.run_template('start.html')


class Page1Page:
    name = 'page1'
    def page_process(self, ctx):
        pdebug(ctx.sesid(), '(Page1Page.page_process)\n')
        if ctx.req_equals('next_page'):
            ctx.set_page('finish')
    def page_enter(self, ctx):
        pdebug(ctx.sesid(), '(Page1Page.page_enter)\n')
    def page_leave(self, ctx):
        pdebug(ctx.sesid(), '(Page1Page.page_leave)\n')
    def page_display(self, ctx):
        pdebug(ctx.sesid(), '(Page1Page.page_display)\n')
        pdebug(ctx.sesid(), '(Page1Page.page_display) value_2: %s\n' % \
               ctx.locals.value_2)
        ctx.run_template('page1.html')


class Page2Page:
    name = 'page2'
    def page_process(self, ctx):
        pdebug(ctx.sesid(), '(Page2Page.page_process)\n')
        if ctx.req_equals('next_page'):
            if ctx.locals.next_page == 'start':
                ctx.set_page('start')
                ctx.locals.next_page = 'page1'
            elif ctx.locals.next_page == 'page3':
                ctx.set_page('page3')
                # Set the checkbox.
                ctx.locals.next_page = 'page2'
            elif ctx.locals.next_page == 'finish':
                ctx.set_page('finish')
    def page_enter(self, ctx):
        pdebug(ctx.sesid(), '(Page2Page.page_enter)\n')
    def page_leave(self, ctx):
        pdebug(ctx.sesid(), '(Page2Page.page_leave)\n')
    def page_display(self, ctx):
        pdebug(ctx.sesid(), '(Page2Page.page_display)\n')
        pdebug(ctx.sesid(), '(Page2Page.page_display) value_1: %s\n' % \
               ctx.locals.value_1)
        ctx.run_template('page2.html')


class Page3Page:
    name = 'page3'
    def page_process(self, ctx):
        pdebug(ctx.sesid(), '(Page3Page.page_process)\n')
        if ctx.req_equals('B1'):
            if ctx.locals.next_page == 'page2':
                ctx.set_page('page2')
                # Set the checkbox.
                ctx.locals.next_page = 'page3'
            elif ctx.locals.next_page == 'finish':
                ctx.set_page('finish')
    def page_enter(self, ctx):
        pdebug(ctx.sesid(), '(Page3Page.page_enter)\n')
    def page_leave(self, ctx):
        pdebug(ctx.sesid(), '(Page3Page.page_leave)\n')
    def page_display(self, ctx):
        pdebug(ctx.sesid(), '(Page3Page.page_display)\n')
        ctx.run_template('page3.html')


class FinishPage:
    name = 'finish'
    def page_process(self, ctx):
        id = ctx.sesid()
        pdebug(id, '(FinishPage.page_process) dir(ctx.locals): %s\n' % \
            dir(ctx.locals))
        pdebug(id, '(FinishPage.page_process) ctx.req_equals("B1"): %s\n' % \
            ctx.req_equals('B1'))
        if ctx.req_equals('B1'):
            #ctx.set_save_session(0)
            pdebug(ctx.sesid(), '(FinishPage.page_process) removing session\n')
            ctx.remove_session()
            ctx.set_page('start')
    def page_enter(self, ctx):
        pdebug(ctx.sesid(), '(FinishPage.page_enter)\n')
    def page_leave(self, ctx):
        pdebug(ctx.sesid(), '(FinishPage.page_leave)\n')
    def page_display(self, ctx):
        pdebug(ctx.sesid(), '(FinishPage.page_display)\n')
        ctx.run_template('finish.html')


class ThankYouPage:
    name = 'thankyou'
    def page_process(self, ctx):
        pdebug(ctx.sesid(), '(ThankYouPage.page_process)\n')
        if ctx.req_equals(''):
            ctx.set_save_session(0)
            ctx.remove_session()
    def page_enter(self, ctx):
        pdebug(ctx.sesid(), '(ThankYouPage.page_enter)\n')
    def page_leave(self, ctx):
        pdebug(ctx.sesid(), '(ThankYouPage.page_leave)\n')
    def page_display(self, ctx):
        pdebug(ctx.sesid(), '(ThankYouPage.page_display)\n')
        pdebug(ctx.sesid(), '(ThankYouPage.page_display) value_2: %s\n' % \
               ctx.locals.value_2)
        ctx.run_template('thankyou.html')


class AppContext(SessionFileAppContext):
    def __init__(self, app):
        SessionFileAppContext.__init__(self, app)
    def load_session(self):
        pdebug(self.sesid(), '(AppContext.load_session)\n')
        SessionFileAppContext.load_session(self)
    def save_session(self):
        pdebug(self.sesid(), '(AppContext.save_session)\n')
        SessionFileAppContext.save_session(self)


class App(SimpleSessionFileApp):
    def __init__(self):
        SimpleSessionFileApp.__init__(self,
            base_url = 'dispatch.py',
            template_path = '.',
            start_page = 'start',
            secret = 'finch',
            session_appid = 'app2',
            session_dir='/w2/Python/albatross-0.06/session-server/SessionData')
        for page_class in (StartPage, Page1Page, Page2Page, \
            Page3Page, FinishPage, ThankYouPage):
            self.register_page(page_class.name, page_class())
    def create_context(self):
        return AppContext(self)


if __name__ == '__main__':
    app = App()
    app.run(Request())

